!片持ち梁の横ねじれ座屈の線形解析(CCX)
! 弾性体、等方性材料

! 実行例：
! $./sz>sz.inp

implicit real*8(a-h,o-z)
dimension x(1000000),y(1000000),z(1000000),e66(6,6),b(3,3)&
&,mesh(30000000,8)
!プログラムはメートル、MPa、
!寸法
b1=2.0d-2!幅(m)
h=25.d-2!高さ(m)
ell=2.0d0!長さ(m)
p=1.0d0!荷重(MN)
!xyz方向の分割数
nx=6
ny=30
nz=200
!1つあたりの要素の長さ
xn=b1/nx
yn=h/ny
zn=ell/nz
! 節点番号ごとの節点座標!i~mで始まるのがdoで使える 
do k=0,nz!z
do j=0,ny!
do i=0,nx!x方向分割数を担当
nset=1+i+j*(nx+1)+k*((nx+1)*(ny+1))
x(nset)=i*xn
y(nset)=j*yn
z(nset)=k*zn
end do
end do
end do 
!i5~6が整数,aが文字,f9,6が小数.1peとかはEの＊乗
!接点番号と座標の出力
nsettenzenbu=(nx+1)*(ny+1)*(nz+1)
print'("*NODE, NSET=Nall")'
do i=1,nsettenzenbu
print'(i6,a,f9.6,a,f9.6,a,f9.6)',&
    &i,',',x(i),',',y(i),',',z(i)
nsettensuu=i
end do
!要素番号とその要素の8接点の節点番号
nyou=0
do k=0,nz-1
do j=0,ny-1
do i=1,nx
nyou=nyou+1
mesh(nyou,1)=i+j*(nx+1)+k*((nx+1)*(ny+1))
mesh(nyou,2)=mesh(nyou,1)+(nx+1)
mesh(nyou,3)=mesh(nyou,2)+(nx+1)*(ny+1)
mesh(nyou,4)=mesh(nyou,1)+(nx+1)*(ny+1)
mesh(nyou,5)=mesh(nyou,1)+1
mesh(nyou,6)=mesh(nyou,5)+nx+1
mesh(nyou,7)=mesh(nyou,6)+(nx+1)*(ny+1)
mesh(nyou,8)=mesh(nyou,5)+(nx+1)*(ny+1)
end do
end do
end do
!要素の出力
print'("*ELEMENT, TYPE=C3D8, ELSET=E1")'
do i=1,nyou
print'(i6,a,i6,a,i6,a,i6,a,i6,a,i6,a,i6,a,i6,a,i6)',&
    &i,',',&
    &mesh(i,1),',',&
    &mesh(i,2),',',&
    &mesh(i,3),',',&
    &mesh(i,4),',',&
    &mesh(i,5),',',&
    &mesh(i,6),',',&
    &mesh(i,7),',',&
    &mesh(i,8)
end do
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
nitimen=(nx+1)*(ny+1)
!固定端の節点群を書きだす
print'("*NSET,NSET=kotei")'
do i=1,nitimen
nkotei=i
print'(i6,a)',nkotei
end do
!載荷点の節点群を書きだす
print'("*NSET,NSET=saika")'
do i=1,nitimen
nsaika=nitimen*nz+i
print'(i6,a)',nsaika
end do
!境界条件
print'("*BOUNDARY")'
print'("kotei,1,3")'
! 木材の設定
print'("*MATERIAL,NAME=EL1")'
print'("*ELASTIC")'
print'("7.694d3, 0.4d0")'
print'("*SOLID SECTION,ELSET=E1,MATERIAL=EL1")'
! 載荷条件
print'("*STEP")'
print'("*STATIC,SOLVER=SPOOLES")'
print'("*BUCKLE")'
print'("5,0.01")'
print'("*CLOAD")'
print'(A,a,i6,a,1pe13.5)','saika',',',2,',',p/nitimen
! datのオプション
print'("*NODE PRINT,NSET=Nall")'
print'("U")'
print'("*EL PRINT,ELSET=Eall")'
print'("S")'
print'("*NODE FILE")'
print'("U")'
print'("*EL FILE,POSITION=AVERAGED AT NODES")'
print'("S")'
print'("*END STEP")'
!
end

